
; Xors3D Physics test - third  attempt by Lupin
; physics simulation independant from frame rate
; Revision 526 or newest needed !

;Include "xors3d.bb"
Include "d:\tools\blitz3d\userlibs\xors3d.bb"

xCreateLog()
; init
xSetAntiAliasType xGetMaxAntiAlias()
xAppTitle "Pick drag drop throw items"
xGraphics3D 800, 600, 32, False, 1;False
xCreateDSS 1024, 1024
xHidePointer
xAntiAlias True

; physics setup
Global delta# = 1.0
Global gravity# = 9.8

; loading textures
Global roomTexture = xLoadTexture("concrete.dds")
xScaleTexture roomTexture, 0.01, 0.01

; create light
Global sun = xCreateLight()
xRotateEntity sun, 45, 45, 0

; some vars for mouse look
Global center_x = xGraphicsWidth() / 2
Global center_y = xGraphicsHeight() / 2
Global mousespeed# = 0.3
Global camerasmoothness# = 4.5
Global camxa# = 0, camya# = 0, mxs# = 0, mys# = 0
xMoveMouse center_x, center_y

; this is a joint and picked item
Const wallSize = 7
Dim wallBlocks(wallSize, wallSize)
Global joint  = 0
Global item   = 0
Global player = 0
Global camera = 0
Global room = 0
Global boxSize# = 1

Global rec = 0

; create environment
CreateRoom
CreateWall
CreatePlayer

; set shadows params
xAmbientLight 160,160,160
xInitShadows 1024, 0, 0
xSetShadowParams 4, 0.99, True, 100
xLightEnableShadows sun, True
xLightShadowEpsilons sun, 0.0001, 0.16
xCameraEnableShadows camera

; ========================================================

; main program loop
While Not xKeyDown(KEY_ESCAPE)
  ; calc delta for physics
  ;If xGetFPS()>10 Then delta# = 60.0/xGetFPS() : Else delta# = 1.0
  ;gravity# = 9.8*delta
  ;xWorldGravity 0, -gravity, 0
  ; do frame
  UpdatePlayer(8)
  xUpdateWorld
	
  xRenderWorld 1, True
  
  DrawHUD
  xFlip
    
Wend

; ========================================================

; function to create player
Function CreatePlayer()
  player = xCreatePivot()
  xPositionEntity player, 0, 3, -5
  ;xEntityAddSphereShape player, 10, 1
  xEntityAddCapsuleShape player, 10, .5, 1
	xEntitySetAngularFactor player, 0, 1, 0
	xEntitySetDamping player, 0.9, 0.9
	xEntitySetGravity player, 0.0, 0.0, 0.0
  camera = xCreateCamera()
  xCameraZoom camera, 0.3
	xEntityAddDummyShape camera
	;xEntityAddBoxShape camera, 1.0
End Function

; function to create room
Function CreateRoom()
  ; create room
  room = xCreateCube()
  xEntityTexture room, roomTexture
  xScaleEntity room, 1000, 1, 1000
  ;xEntityAddTriMeshShape room, 0
  xEntityAddBoxShape room, 0
	xEntitySetFriction room, 2
  ; shadows
  xEntityReceiveShadows room, sun, True
  xEntityCastShadows room, sun, False
End Function

; function to create wall
Function CreateWall()
  For x = 0 To wallSize
		For y = 0 To wallSize
			If (x = 0 And y = 0)
				wallBlocks(x, y) = xLoadMesh ("cube1.b3d")
			Else
				wallBlocks(x, y) = xCopyEntity(wallBlocks(0,0))
			EndIf
	  xScaleMesh wallBlocks(x, y), boxSize, boxSize, boxSize
      xPositionEntity(wallBlocks(x, y), (x-wallSize/2)*boxSize, boxSize/2+y*boxSize+1, 0)
      xEntityAddBoxShape(wallBlocks(x, y), 10)
      xEntityPickMode wallBlocks(x, y), 2 ; Make the box 'pickable'
	  ; effects
	  xEntityShininess wallBlocks(x, y), 1
      ; shadows
      xEntityReceiveShadows wallBlocks(x, y), sun, True
	xEntityCastShadows wallBlocks(x, y), sun, True
    Next
  Next
End Function

; function to reset cubes positions
Function ResetWall()
  If joint Then DropItem
  For x = 0 To wallSize
    For y = 0 To wallSize
      xPositionEntity(wallBlocks(x, y), (x-wallSize/2)*boxSize, boxSize/2+y*boxSize+1, 0)
      xRotateEntity(wallBlocks(x, y), 0, 0, 0)
      xEntityReleaseForces(wallBlocks(x, y))
    Next
  Next
End Function

; function to pick up item by camera pick
Function PickUpItem()
  If joint Then
    DropItem
  Else
    xCameraPick(camera, xMouseX(), xMouseY()) ; pick cube
    If xPickedEntity() Then
      If xEntityDistance(camera,xPickedEntity())<boxSize * 5 Then
        item = xPickedEntity()
        xEntityColor item, 255,200,0
        xEntitySetDamping item, 0.95, 0.95
		Local jointX# = (xEntityX(item, 1) + 0.5 * xEntityX(camera, 1)) / 1.5;xEntityX(item, 1)
		Local jointY# = (xEntityY(item, 1) + 0.5 * xEntityY(camera, 1)) / 1.5;xEntityY(item, 1)
		Local jointZ# = (xEntityZ(item, 1) + 0.5 * xEntityZ(camera, 1)) / 1.5;xEntityZ(item, 1)
		;joint = xCreateD6Joint(camera, item, jointX, jointY, jointZ, jointX, jointY, jointZ, 1, 1)
		joint = xCreateD6Joint(camera, item, jointX, jointY, jointZ, xEntityX(item, 1), xEntityy(item, 1), xEntityz(item, 1), 1, 1)
		;xJointD6SetLinearLimits joint, 0,0,boxSize * 0.2, 0,0,boxSize * 0.2; face-to-face with camera
		xJointD6SetLinearLimits joint, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
		xEntityDisableSleeping(item, 1)
      EndIf
    EndIf
  EndIf
End Function

; function to drop item
Function DropItem()
  If joint Then
		If item Then
			xEntityColor item, 255,255,255
			xEntitySetDamping item, 0, 0
			xEntityReleaseForces item
			xEntityDisableSleeping(item, 0)
    EndIf
    xFreeJoint(joint) : joint = 0 : item = 0
  EndIf
End Function

; function to throw item
Function ThrowItem()
  If joint Then
    xFreeJoint(joint) : joint = 0
    If item Then
      xEntityColor item, 255,255,255
	xEntitySetDamping item, 0, 0
      xTFormNormal 0, 0, 1, camera, 0 ; camera Z direction
      xEntityApplyCentralImpulse(item, xTFormedX()*300*delta, xTFormedY()*300*delta, xTFormedZ()*300*delta)
      xEntityApplyTorqueImpulse(item, 10, 1, -1);
      item = 0
    EndIf
  EndIf
End Function

; Function for drawing infos
Function DrawHUD()
  xText center_x, center_y, "+"
  xText 5, 5, "WSAD - move, LMB or E - pick/drop item, RMB - throw item, SPACE - reset wall."
	xText 5, 25, "FPS: " + xGetFPS()
End Function

; return max contact distance - for preventing penetration
Function MaxContactDist#( ent% )
  md# = 0
  If ent Then
		If xEntityCountContacts(ent)>0 Then
			For i=0 To xEntityCountContacts(ent)-1
				If Abs(xEntityGetContactDistance(ent,i))>md Then md=Abs(xEntityGetContactDistance(ent,i))
      Next
    EndIf
  EndIf
  Return md
End Function

; sphere character controller
Function UpdatePlayer(speed#=10.0)
   ; actions
   If xKeyHit (KEY_F12) Then xSaveBuffer(xBackBuffer(), "screenshot.bmp")
   If xKeyHit (KEY_SPACE) Then ResetWall
   If xMouseHit(1) Or xKeyHit(KEY_E) Then PickUpItem ; LMB - pick or drop
   If xMouseHit(2) Then ThrowItem  ; RMB - throw
   ; go forward or backward
   movz# = (xKeyDown(KEY_W)-xKeyDown(KEY_S))*speed
   If movz<>0 Then
      xTFormNormal 0, 0, 1, camera, 0 ; camera Z direction
      xEntityApplyCentralImpulse player, xTFormedX()*movz*delta, xTFormedY()*movz*delta, xTFormedZ()*movz*delta
   EndIf
   ; strafe left or right
   movx# = (xKeyDown(KEY_D)-xKeyDown(KEY_A))*speed ;*0.75
   If movx<>0 Then
      xTFormNormal 1, 0, 0, camera, 0 ; camera X direction
      xEntityApplyCentralImpulse player, xTFormedX()*movx*delta, xTFormedY()*movx*delta, xTFormedZ()*movx*delta
   EndIf
   ; anti-gravitation
   ;xEntityApplyCentralImpulse player, 0, gravity/10.0, 0
   ; update camera position - follow player ball
   xPositionEntity camera, xEntityX(player), xEntityY(player)+0.8, xEntityZ(player)
   ; mouse free look
   mxs# = CurveValue(xMouseXSpeed() * mousespeed, mxs, camerasmoothness)
   mys# = CurveValue(xMouseYSpeed() * mousespeed, mys, camerasmoothness)
   camxa = camxa - mxs Mod 360
   camya = camya + mys
   If camya < -89 Then camya = -89
   If camya >  89 Then camya =  89
   xRotateEntity camera, camya, camxa, 0
   xMoveMouse center_x, center_y
   xEntityReleaseForces camera
   ; preventing penetration
   If MaxContactDist(item)>0.1 Then DropItem
End Function

; smooth increment
Function CurveValue#(newvalue#, oldvalue#, increments)
   If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments
   If increments <= 1 Then oldvalue# = newvalue#
   Return oldvalue#
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D